=begin
= Sary Ruby Binding Reference

== Suffix Array Ѥ
ե filename Ф pattern ǸԤ̤иֽ˥Ȥñ̤ɽǤ


 #!/usr/local/bin/ruby

 require 'sary'

 pattern = ARGV.shift

 ARGV.each {|filename|
     saryer = Sary::Saryer.new(filename)
     if saryer.search(pattern)
         saryer.sort_occurrences
         saryer.each_context_line {|text| print text, "\n" }
     end
 }

== Suffix Array 
Ƭ˥ǥå ݥȤƤǤ 

 #!/usr/local/bin/ruby

 require 'sary'

 filename = ARGV.shift
 arrayname = filename + ".ary"

 text = open(filename, "r")
 array = open(arrayname, "w")

 offset = 0
 text.each {|line|
     array.print [offset].pack('N')
     offset += line.length
 }
 text.close
 array.close

 builder = Sary::Builder.new(filename, arrayname)
 builder.block_sort

== Sary module
Sary::Saryer  Sary::Builder 2ĤΥ饹ޤߤޤ

== Saryer class
array եʤȥƥȥեˤΥ饹Ǥ

Saryer#count_occurrences ʳΥ󥹥󥹥᥽åɤ˲Ūʥ᥽å
Ǥ

--- Saryer.new(filename[,arrayname])
    Τ˥ƥȥե array ե򳫤ޤ
    ˥ƥȥե̾ array ե̾ꤷޤ
    array ե̾ά ((|filename|)).ary Ȥޤ

    Ԥ (({IOError})) 㳰ȯޤ

--- Saryer#search(pattern)
    ɸԤʤޤ

     (({true}))Ԥ (({false})) ֤ޤ

--- Saryer#isearch(pattern, len)
    Ψɤ󥯥󥿥븡Ԥʤޤ
    ((|pattern|)) ꤷơ((|len|)) ͤ ((|pattern|))Ĺ
    ޤǽ 礭ʤϢ³ƸƤӽФȤˤꥤ󥯥󥿥
    ޤ

    ((<Saryer#sort_occurrences>)) ȤʻѤϤǤޤ

     (({true}))Ԥ (({false})) ֤ޤ

--- Saryer#isearch_reset
    ((<Saryer#isearch>)) Ѥ֤ꥻåȤޤ

     pattern  ((<Saryer#isearch>)) ƤӽФȤϡˤ
    δؿ¹Ԥ֤ꥻåȤƤ

--- Saryer#icase_search(pattern)
    ե٥åȤʸʸ̤ʤԤʤޤ

     (({true}))Ԥ (({false})) ֤ޤ

--- Saryer#get_next_context_line
    θ̤ñ̤ǼФޤ

    δؿϢ³ƸƤ֤ȡ٤Ƥθ̤ޤĤθ
    ̤ʤȤ (({nil})) ֤ޤ

--- Saryer#get_next_context_lines([bkwrd, frwrd])
    θ̤򥳥ƥȹñ(ľ((|bkwrd|))ԡľ
    ((|frwrd|)))ǼФޤ

    δؿϢ³ƸƤ֤ȡ٤Ƥθ̤ޤĤθ
    ̤ʤȤ (({nil})) ֤ޤ

--- Saryer#each_context_line{|text| ...}
    ̤ޤԤФ륤ƥ졼

--- Saryer#each_context_lines([bkwrd, frwrd]){|text| ...}
    ̤ޤॳƥȹԤФ륤ƥ졼

--- Saryer#get_next_context_region(start_tag, end_tag)
    θ̤ ((|start_tag|))  ((|end_tag|)) ǰϤޤ줿ΰȤ
    ƼФޤ(((|start_tag|))  ((|end_tag|)) ޤߤޤ)

    δؿϢ³ƸƤ֤ȡ٤Ƥθ̤ޤĤθ
    ̤ʤȤ (({nil})) ֤ޤ

--- Saryer#count_occurrences
    Υҥåȿ֤ޤ

--- Saryer#sort_occurrences
    ̤иֽ˥Ȥޤ

--- Saryer#enable_cache
    å嵡Ưޤ̤򥭥å夷Ʊѥ
     2ܰʹߤθ®ޤ

--- Saryer.array_sort(filename)
    ((|filename|)).ary ե򥽡Ȥޤ

    Ԥ (({IOError})) 㳰ȯޤ

== Builder class
Suffix Array 뤿Υ饹Ǥ

--- Builder.new(filename[,arrayname])
    ˥ƥȥե̾ array ե̾ꤷޤ
    array ե̾ά ((|filename|)).ary Ȥޤ

    Ԥ (({IOError})) 㳰ȯޤ

--- Builder#sort [{|task, current, total, is_finished|...}]
    Suffix Array ΥȤԤʤޤ

    ץ쥹Сɽ뤿Υ֥åϤȤǤޤ

    Ԥ (({RuntimeError})) 㳰ȯޤ

--- Builder#block_sort [{|task, current, total, is_finished|...}]
    Suffix Array ΥȤԤʤޤ֥åñ̤ǥȤԤʤ
    ᡢǤޤ

    ץ쥹Сɽ뤿Υ֥åϤȤǤޤ

    Ԥ (({RuntimeError})) 㳰ȯޤ

--- Builder#set_block_size(size)
    ((<Builder#block_sort>)) ΤΥ֥åꤷޤ

--- Builder#set_nthread(n)
    ((<Builder#block_sort>)) ԤʤȤΥåɤοꤷޤ

    CPU ʣ׻Ǥ®٤夷ޤ
=end
$Id: Reference.ja.rd,v 1.2 2000/12/22 11:22:42 kazuma Exp $
